#! /usr/bin/env python
# Semplice script di correzione di DN non corrisponti agli utenti
#
# Copyright (C) 2007 Simone Piccardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from os import *
import re
import getopt, sys

flags = re.S|re.M
utente = ''

try:
    opts, args = getopt.getopt(sys.argv[1:], 'iu:')
    for opt, val in opts:
        if opt == '-i':
            flags = flags | re.IGNORECASE
        if opt == '-u':
            utente = val

except getopt.GetoptError:
    print "Usage: correctdn.py [-i] [-u utente] files ..."
    sys.exit(2)

#
# Ciclo sui files passati come argomenti
#
for conffile in args:
    datafile = file(conffile) 
    data = datafile.read()

    # Espressione regolare per i tag
    if utente:
        regexp=r'^dn: uid='+utente+r',.*?^uid: (?!'+utente+r'\n).*?\n\n'
        p = re.compile(regexp, flags)
        for i in p.findall(data):
            regexp=r'^dn: uid='+utente+r',.*?^uid: '+utente+r'\n'
            pp = re.compile(regexp, flags)
            if pp.findall(i):
                print i
            else:
                regexp=r'dn: uid=([^,$]*),.*?^uid: (.*?)\n'
                ppp = re.compile(regexp, flags)
                for j,k in ppp.findall(i):
                    print j,k
                    print '===========ORIGINAL============='
                    print i
                    print '===========MODIFIED============='
                    print re.sub(r'uid='+j,r'uid='+k,i)
    else:
        regexp=r'(^dn: .*?\n\n)'
        p = re.compile(regexp, flags)
        for i in p.findall(data):
            regexp=r'dn: uid=([^,$]*),.*?^uid: (?!\1\n)'
            p = re.compile(regexp, flags)
            if p.findall(i):
#                print p.findall(i)
                regexp=r'dn: uid=([^,$]*),.*?^uid: (.*?)\n'
                ppp = re.compile(regexp, flags)
                for j,k in ppp.findall(i):
#                    print j,k
#                    print '===========ORIGINAL============='
#                    print i
#                    print '===========MODIFIED============='
                    print re.sub(r'uid='+j,r'uid='+k,i),
            else: 
                print i,
    
    sys.exit(1)            
